import logging

logging.basicConfig(level=logging.DEBUG)

from cache import get_cache
from receive import receive_links, receive_link_graph

from dijkstra import prepare_dijkstra, dijkstra
from connectivity import shortest_path

cache = get_cache("./cache/", "Angela_Merkel")
receive_link_graph("Angela_Merkel", cache, 2)

cursor = cache.cursor()
cursor.execute("SELECT COUNT(source) FROM links")
print(cursor.fetchall())

#prepare_dijkstra(cache)
#dijkstra("Angela_Merkel", cache)

print(shortest_path("Angela_Merkel", "Germany", cache))
